libstdc++: __gnu_pbds::tree_order_statistics_node_update< Node_CItr, Node_Itr, Cmp_Fn, _Alloc > Class Template Reference

libstdc++

__gnu_pbds::tree_order_statistics_node_update< Node_CItr, Node_Itr, Cmp_Fn, _Alloc > Class Template Referenceabstract

`#include <tree_policy.hpp>`

Inheritance diagram for __gnu_pbds::tree_order_statistics_node_update< Node_CItr, Node_Itr, Cmp_Fn, _Alloc >:
[legend]

## Public Types
typedef _Alloc | allocator_type
typedef Cmp_Fn | cmp_fn
typedef node_const_iterator::value_type | const_iterator
typedef node_iterator::value_type | iterator
typedef base_type::key_const_reference | key_const_reference
typedef base_type::key_type | key_type
typedef size_type | metadata_type
typedef Node_CItr | node_const_iterator
typedef Node_Itr | node_iterator
typedef allocator_type::size_type | size_type

## Public Member Functions
iterator | find_by_order (size_type)
const_iterator | find_by_order (size_type) const
size_type | order_of_key (key_const_reference) const

## Protected Member Functions
void | operator() (node_iterator, node_const_iterator) const

## Detailed Description

template<typename Node_CItr, typename Node_Itr, typename Cmp_Fn, typename _Alloc>
class __gnu_pbds::tree_order_statistics_node_update< Node_CItr, Node_Itr, Cmp_Fn, _Alloc >

Functor updating ranks of entrees.

Definition at line 64 of file tree_policy.hpp.

## Member Typedef Documentation

## ◆ allocator_type

template<typename Node_CItr, typename Node_Itr, typename Cmp_Fn, typename _Alloc>

typedef _Alloc __gnu_pbds::tree_order_statistics_node_update< Node_CItr, Node_Itr, Cmp_Fn, _Alloc >::allocator_type

Definition at line 71 of file tree_policy.hpp.

## ◆ cmp_fn

template<typename Node_CItr, typename Node_Itr, typename Cmp_Fn, typename _Alloc>

typedef Cmp_Fn __gnu_pbds::tree_order_statistics_node_update< Node_CItr, Node_Itr, Cmp_Fn, _Alloc >::cmp_fn

Definition at line 70 of file tree_policy.hpp.

## ◆ const_iterator

template<typename Node_CItr, typename Node_Itr, typename Cmp_Fn, typename _Alloc>

typedef node_const_iterator::value_type __gnu_pbds::tree_order_statistics_node_update< Node_CItr, Node_Itr, Cmp_Fn, _Alloc >::const_iterator

Definition at line 79 of file tree_policy.hpp.

## ◆ iterator

template<typename Node_CItr, typename Node_Itr, typename Cmp_Fn, typename _Alloc>

typedef node_iterator::value_type __gnu_pbds::tree_order_statistics_node_update< Node_CItr, Node_Itr, Cmp_Fn, _Alloc >::iterator

Definition at line 80 of file tree_policy.hpp.

## ◆ key_const_reference

template<typename Node_CItr, typename Node_Itr, typename Cmp_Fn, typename _Alloc>

typedef base_type::key_const_reference __gnu_pbds::tree_order_statistics_node_update< Node_CItr, Node_Itr, Cmp_Fn, _Alloc >::key_const_reference

Definition at line 74 of file tree_policy.hpp.

## ◆ key_type

template<typename Node_CItr, typename Node_Itr, typename Cmp_Fn, typename _Alloc>

typedef base_type::key_type __gnu_pbds::tree_order_statistics_node_update< Node_CItr, Node_Itr, Cmp_Fn, _Alloc >::key_type

Definition at line 73 of file tree_policy.hpp.

## ◆ metadata_type

template<typename Node_CItr, typename Node_Itr, typename Cmp_Fn, typename _Alloc>

typedef size_type __gnu_pbds::tree_order_statistics_node_update< Node_CItr, Node_Itr, Cmp_Fn, _Alloc >::metadata_type

Definition at line 76 of file tree_policy.hpp.

## ◆ node_const_iterator

template<typename Node_CItr, typename Node_Itr, typename Cmp_Fn, typename _Alloc>

typedef Node_CItr __gnu_pbds::tree_order_statistics_node_update< Node_CItr, Node_Itr, Cmp_Fn, _Alloc >::node_const_iterator

Definition at line 77 of file tree_policy.hpp.

## ◆ node_iterator

template<typename Node_CItr, typename Node_Itr, typename Cmp_Fn, typename _Alloc>

typedef Node_Itr __gnu_pbds::tree_order_statistics_node_update< Node_CItr, Node_Itr, Cmp_Fn, _Alloc >::node_iterator

Definition at line 78 of file tree_policy.hpp.

## ◆ size_type

template<typename Node_CItr, typename Node_Itr, typename Cmp_Fn, typename _Alloc>

typedef allocator_type::size_type __gnu_pbds::tree_order_statistics_node_update< Node_CItr, Node_Itr, Cmp_Fn, _Alloc >::size_type

Definition at line 72 of file tree_policy.hpp.

## Constructor & Destructor Documentation

## ◆ ~tree_order_statistics_node_update()

template<typename Node_CItr, typename Node_Itr, typename Cmp_Fn, typename _Alloc>

__gnu_pbds::tree_order_statistics_node_update< Node_CItr, Node_Itr, Cmp_Fn, _Alloc >::~tree_order_statistics_node_update | ( |  | ) |
| protectedvirtual

Definition at line 122 of file tree_policy.hpp.

## Member Function Documentation

## ◆ find_by_order() [1/2]

template<typename Node_CItr, typename Node_Itr, typename Cmp_Fn, typename _Alloc>

tree_order_statistics_node_update< Node_CItr, Node_Itr, Cmp_Fn, _Alloc >::iterator __gnu_pbds::tree_order_statistics_node_update< Node_CItr, Node_Itr, Cmp_Fn, _Alloc >::find_by_order | ( | size_type | order | ) |
| inline

Finds an entry by __order. Returns an iterator to the entry with the __order order, or an iterator to the container object's end if order is at least the size of the container object.

Definition at line 46 of file tree_policy.hpp.

## ◆ find_by_order() [2/2]

template<typename Node_CItr, typename Node_Itr, typename Cmp_Fn, typename _Alloc>

tree_order_statistics_node_update< Node_CItr, Node_Itr, Cmp_Fn, _Alloc >::const_iterator __gnu_pbds::tree_order_statistics_node_update< Node_CItr, Node_Itr, Cmp_Fn, _Alloc >::find_by_order | ( | size_type | order | ) | const
| inline

Finds an entry by __order. Returns a const_iterator to the entry with the __order order, or a const_iterator to the container object's end if order is at least the size of the container object.

Definition at line 73 of file tree_policy.hpp.

## ◆ operator()()

template<typename Node_CItr, typename Node_Itr, typename Cmp_Fn, typename _Alloc>

void __gnu_pbds::tree_order_statistics_node_update< Node_CItr, Node_Itr, Cmp_Fn, _Alloc >::operator() | ( | node_iterator | node_it,
|  | node_const_iterator | end_nd_it ) const
| inlineprotected

Updates the rank of a node through a node_iterator node_it; end_nd_it is the end node iterator.

Definition at line 109 of file tree_policy.hpp.

## ◆ order_of_key()

template<typename Node_CItr, typename Node_Itr, typename Cmp_Fn, typename _Alloc>

tree_order_statistics_node_update< Node_CItr, Node_Itr, Cmp_Fn, _Alloc >::size_type __gnu_pbds::tree_order_statistics_node_update< Node_CItr, Node_Itr, Cmp_Fn, _Alloc >::order_of_key | ( | key_const_reference | r_key | ) | const
| inline

Returns the order of a key within a sequence. For example, if r_key is the smallest key, this method will return 0; if r_key is a key between the smallest and next key, this method will return 1; if r_key is a key larger than the largest key, this method will return the size of r_c.

Definition at line 79 of file tree_policy.hpp.

The documentation for this class was generated from the following file:

- tree_policy.hpp